/*****************************************************************************\
 *                        ANALYSIS PERFORMANCE TOOLS                         *
 *                                   Extrae                                  *
 *              Instrumentation package for parallel applications            *
 *****************************************************************************
 *     ___     This library is free software; you can redistribute it and/or *
 *    /  __         modify it under the terms of the GNU LGPL as published   *
 *   /  /  _____    by the Free Software Foundation; either version 2.1      *
 *  /  /  /     \   of the License, or (at your option) any later version.   *
 * (  (  ( B S C )                                                           *
 *  \  \  \_____/   This library is distributed in hope that it will be      *
 *   \  \__         useful but WITHOUT ANY WARRANTY; without even the        *
 *    \___          implied warranty of MERCHANTABILITY or FITNESS FOR A     *
 *                  PARTICULAR PURPOSE. See the GNU LGPL for more details.   *
 *                                                                           *
 * You should have received a copy of the GNU Lesser General Public License  *
 * along with this library; if not, write to the Free Software Foundation,   *
 * Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA          *
 * The GNU LEsser General Public License is contained in the file COPYING.   *
 *                                 ---------                                 *
 *   Barcelona Supercomputing Center - Centro Nacional de Supercomputacion   *
\*****************************************************************************/

#ifndef _SAMPLING_H_INCLUDED_
#define _SAMPLING_H_INCLUDED_

enum
{
	SAMPLING_TIMING_REAL,
	SAMPLING_TIMING_VIRTUAL,
	SAMPLING_TIMING_PROF,
	SAMPLING_TIMING_DEFAULT = SAMPLING_TIMING_REAL
};

void setTimeSampling (unsigned long long period, unsigned long long variability, int sampling_type);
void setTimeSampling_postfork (void);
void Extrae_SamplingHandler (void* address);
void Extrae_SamplingHandler_PAPI (void *address);

void unsetTimeSampling (void);

#endif
